#include <bits/stdc++.h>

using namespace std;
#define int long long

int n , k;
deque<int>v;
int m;
int a[100017];
void pre(int l , int r){
  int md = (l + r) / 2;
  if (v.size() == m || md == l || md == r)return;
  v.push_back(md);
  if (v.size() == m ||  md == l || md == r)return;
  pre(l , md);
  pre(md , r);
}

int to_int(string s){
  int x = 0;
  for (int i = 1 ; i < s.size() ; i ++){
    x *= 10;
    x += (s[i] - '0');
  }
  return x;
}

void PON(){
  set<int>st;
  int num = 1 , x;
  cin >> n >> k ;
  m = min(n , k);
  v.push_back(1);
  v.push_back(n);
  pre(1 , n);
  string z;
  for (int i = 1 ; i <= k ; i ++){
    cin >> z;
    if (z == "+"){
      if (st.size() == 0){
        a[num] = v[0];
        cout << v[0] << endl;
        v.pop_front();
      }else {
        for (auto to:st){
          x = to;
          break;
        }
        a[num] = x;
        cout << x << endl;
        st.erase(x);
      }
      num++;
    }else {
      int x = to_int(z);
      st.insert(a[x]);
      a[x] = 0;
    }
  }
}
signed main () {
    PON();
}